/*
 * Generated by asn1c-0.9.29 (http://lionet.info/asn1c)
 * From ASN.1 module "ITS-Container"
 * 	found in "ITS-Container.asn"
 * 	`asn1c -fcompound-names -gen-PER`
 */

#include "VehicleRole.h"

int
VehicleRole_constraint(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	/* Replace with underlying type checker */
	td->check_constraints = asn_DEF_NativeEnumerated.check_constraints;
	return td->check_constraints(td, sptr, ctfailcb, app_key);
}

/*
 * This type is implemented using NativeEnumerated,
 * so here we adjust the DEF accordingly.
 */
static void
VehicleRole_1_inherit_TYPE_descriptor(asn_TYPE_descriptor_t *td) {
	td->free_struct    = asn_DEF_NativeEnumerated.free_struct;
	td->print_struct   = asn_DEF_NativeEnumerated.print_struct;
	td->check_constraints = asn_DEF_NativeEnumerated.check_constraints;
	td->ber_decoder    = asn_DEF_NativeEnumerated.ber_decoder;
	td->der_encoder    = asn_DEF_NativeEnumerated.der_encoder;
	td->xer_decoder    = asn_DEF_NativeEnumerated.xer_decoder;
	td->xer_encoder    = asn_DEF_NativeEnumerated.xer_encoder;
	td->uper_decoder   = asn_DEF_NativeEnumerated.uper_decoder;
	td->uper_encoder   = asn_DEF_NativeEnumerated.uper_encoder;
	if(!td->per_constraints)
		td->per_constraints = asn_DEF_NativeEnumerated.per_constraints;
	td->elements       = asn_DEF_NativeEnumerated.elements;
	td->elements_count = asn_DEF_NativeEnumerated.elements_count;
     /* td->specifics      = asn_DEF_NativeEnumerated.specifics;	// Defined explicitly */
}

void
VehicleRole_free(asn_TYPE_descriptor_t *td,
		void *struct_ptr, int contents_only) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	td->free_struct(td, struct_ptr, contents_only);
}

int
VehicleRole_print(asn_TYPE_descriptor_t *td, const void *struct_ptr,
		int ilevel, asn_app_consume_bytes_f *cb, void *app_key) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	return td->print_struct(td, struct_ptr, ilevel, cb, app_key);
}

asn_dec_rval_t
VehicleRole_decode_ber(asn_codec_ctx_t *opt_codec_ctx, asn_TYPE_descriptor_t *td,
		void **structure, const void *bufptr, size_t size, int tag_mode) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	return td->ber_decoder(opt_codec_ctx, td, structure, bufptr, size, tag_mode);
}

asn_enc_rval_t
VehicleRole_encode_der(asn_TYPE_descriptor_t *td,
		void *structure, int tag_mode, ber_tlv_tag_t tag,
		asn_app_consume_bytes_f *cb, void *app_key) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	return td->der_encoder(td, structure, tag_mode, tag, cb, app_key);
}

asn_dec_rval_t
VehicleRole_decode_xer(asn_codec_ctx_t *opt_codec_ctx, asn_TYPE_descriptor_t *td,
		void **structure, const char *opt_mname, const void *bufptr, size_t size) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	return td->xer_decoder(opt_codec_ctx, td, structure, opt_mname, bufptr, size);
}

asn_enc_rval_t
VehicleRole_encode_xer(asn_TYPE_descriptor_t *td, void *structure,
		int ilevel, enum xer_encoder_flags_e flags,
		asn_app_consume_bytes_f *cb, void *app_key) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	return td->xer_encoder(td, structure, ilevel, flags, cb, app_key);
}

asn_dec_rval_t
VehicleRole_decode_uper(asn_codec_ctx_t *opt_codec_ctx, asn_TYPE_descriptor_t *td,
		asn_per_constraints_t *constraints, void **structure, asn_per_data_t *per_data) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	return td->uper_decoder(opt_codec_ctx, td, constraints, structure, per_data);
}

asn_enc_rval_t
VehicleRole_encode_uper(asn_TYPE_descriptor_t *td,
		asn_per_constraints_t *constraints,
		void *structure, asn_per_outp_t *per_out) {
	VehicleRole_1_inherit_TYPE_descriptor(td);
	return td->uper_encoder(td, constraints, structure, per_out);
}

static asn_per_constraints_t asn_PER_type_VehicleRole_constr_1 GCC_NOTUSED = {
	{ APC_CONSTRAINED,	 4,  4,  0,  15 }	/* (0..15) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static const asn_INTEGER_enum_map_t asn_MAP_VehicleRole_value2enum_1[] = {
	{ 0,	7,	"default" },
	{ 1,	15,	"publicTransport" },
	{ 2,	16,	"specialTransport" },
	{ 3,	14,	"dangerousGoods" },
	{ 4,	8,	"roadWork" },
	{ 5,	6,	"rescue" },
	{ 6,	9,	"emergency" },
	{ 7,	9,	"safetyCar" },
	{ 8,	11,	"agriculture" },
	{ 9,	10,	"commercial" },
	{ 10,	8,	"military" },
	{ 11,	12,	"roadOperator" },
	{ 12,	4,	"taxi" },
	{ 13,	9,	"reserved1" },
	{ 14,	9,	"reserved2" },
	{ 15,	9,	"reserved3" }
};
static const unsigned int asn_MAP_VehicleRole_enum2value_1[] = {
	8,	/* agriculture(8) */
	9,	/* commercial(9) */
	3,	/* dangerousGoods(3) */
	0,	/* default(0) */
	6,	/* emergency(6) */
	10,	/* military(10) */
	1,	/* publicTransport(1) */
	5,	/* rescue(5) */
	13,	/* reserved1(13) */
	14,	/* reserved2(14) */
	15,	/* reserved3(15) */
	11,	/* roadOperator(11) */
	4,	/* roadWork(4) */
	7,	/* safetyCar(7) */
	2,	/* specialTransport(2) */
	12	/* taxi(12) */
};
static asn_INTEGER_specifics_t asn_SPC_VehicleRole_specs_1 = {
	asn_MAP_VehicleRole_value2enum_1,	/* "tag" => N; sorted by tag */
	asn_MAP_VehicleRole_enum2value_1,	/* N => "tag"; sorted by N */
	16,	/* Number of elements in the maps */
	0,	/* Enumeration is not extensible */
	1,	/* Strict enumeration */
	0,	/* Native long size */
	0
};
static const ber_tlv_tag_t asn_DEF_VehicleRole_tags_1[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (10 << 2))
};
asn_TYPE_descriptor_t asn_DEF_VehicleRole = {
	"VehicleRole",
	"VehicleRole",
	VehicleRole_free,
	VehicleRole_print,
	VehicleRole_constraint,
	VehicleRole_decode_ber,
	VehicleRole_encode_der,
	VehicleRole_decode_xer,
	VehicleRole_encode_xer,
	VehicleRole_decode_uper,
	VehicleRole_encode_uper,
	0,	/* Use generic outmost tag fetcher */
	asn_DEF_VehicleRole_tags_1,
	sizeof(asn_DEF_VehicleRole_tags_1)
		/sizeof(asn_DEF_VehicleRole_tags_1[0]), /* 1 */
	asn_DEF_VehicleRole_tags_1,	/* Same as above */
	sizeof(asn_DEF_VehicleRole_tags_1)
		/sizeof(asn_DEF_VehicleRole_tags_1[0]), /* 1 */
	&asn_PER_type_VehicleRole_constr_1,
	0, 0,	/* Defined elsewhere */
	&asn_SPC_VehicleRole_specs_1	/* Additional specs */
};

